import { Injectable } from '@angular/core';
import {
  HttpEvent, HttpInterceptor, HttpHandler, HttpRequest, HttpResponse
} from '@angular/common/http';
import { Observable, of } from 'rxjs';
import { tap } from 'rxjs/operators';
import { CachingService } from './caching.service';
import { CACHEABLE_URLS } from '../config/caching.config';

@Injectable()
export class CachingInterceptor implements HttpInterceptor {

  constructor(private cache: CachingService) {}

  intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
    if (!this.isCacheable(req)) {
      return next.handle(req);
    }

    const cachedResponse = this.cache.get(this.getCacheKey(req));
    if (cachedResponse) {
      return of(cachedResponse.clone());
    }

    return next.handle(req).pipe(
      tap(event => {
        if (event instanceof HttpResponse) {
          this.cache.put(this.getCacheKey(req), event.clone());
        }
      })
    );
  }

  private isCacheable(req: HttpRequest<any>): boolean {
    if (req.method === 'GET') {
      return CACHEABLE_URLS.GET.some(url => req.urlWithParams.includes(url));
    }

    if (req.method === 'POST') {
      return CACHEABLE_URLS.POST.some(url => req.urlWithParams.includes(url));
    }

    return false;
  }

  private getCacheKey(req: HttpRequest<any>): string {
    if (req.method === 'POST') {
      return req.urlWithParams + JSON.stringify(req.body);
    }
    return req.urlWithParams;
  }
}
